#include "MapMaker.h"
#include <iostream.h>
#include <fstream.h> // for writing a data file

MapMaker::MapMaker(){
	root = NULL;
}

MapMaker::~MapMaker(){
// delete the tree
}

int MapMaker::addRoute(unsigned int *route){
//	if(isListed(route[0]){ return 0; }
	MapNode * node = new MapNode();
	if(!node){
		cout << "Out of memory: cannot allocate map node..." << endl;
		return -1;
	}
	memcpy(node->route,route,sizeof(node->route));
	node->next = root;
	root = node;
	return 0;
}

bool MapMaker::isListed(unsigned int addr){
	for(MapNode * node = root; node; node = node->next){
		if(node->route[0] == addr){
			return true;
		}
	}
	return false;
}


int MapMaker::writeRoute(char *filename){
	if(!root){
		return 0;
	}
	
	ofstream fout(filename);
	if(!fout){
		return 0;
	}
	fout.setmode(filebuf::text);
	for(MapNode * node = root; node; node=node->next){
		for(int i=0; i < MAX_HOPS+1; i++){
			fout << (int)node->route[i] << " ";
		}
		fout << endl;
	}
	fout.close();
	return 0;
}
