#include <winsock2.h>
#include <iostream.h>
#include <time.h>

#include "display.h"
#include "SyncLinkedList.h"
#include "Packets.h"
#include "PacketMuncher.h"
#include "Tracker.h"
#include "MapMaker.h"


LPSTR err(void){
	LPVOID error;
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, NULL,
    GetLastError(),MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), (LPSTR)&error, 0, NULL);
	return (LPSTR) error;
}


DWORD WINAPI capture( LPVOID syncList){ // packet muncher thread procedure
	cout << endl << "Thread started..." << endl;
	PacketMuncher * pakmun = new PacketMuncher();
	if(!pakmun){
		cout << "Out of memory: error allocating memory for packet muncher..."<<endl;
		return -1;
	}
	pakmun->munch( (SyncLinkedList*)syncList );
	cout << endl << "Thread ended..." << endl;
	return 0;
}


void main (void){
char * buff;
Tracker * tracker;
SyncLinkedList * list;
MapMaker * map;
DWORD threadID; // this thread will run our packet muncher
time_t ltime;

	WSADATA data;
	WORD version = MAKEWORD( 2, 2 );
	WSAStartup(version,&data); // it is the responsibility of a program not a class to load the dll

	map = new MapMaker();
	list = new SyncLinkedList();
	tracker = new Tracker();
	if(!list || !tracker ||!map){
		cout << "ERROR: out of memory..." << endl;
		return;
	}

	// we want to capture packets in an asynchronous fasion
	if(!CreateThread(NULL,0,capture,(LPVOID)list,0,&threadID) ){
		cout << "ERROR creating thread " << err() << endl;
		return;
	}
	cout << "Muncher thread number=" << threadID << endl;

	while(true){
		buff = list->get();
		if(!buff){ // if list->get() timed out
			tracker->ping(map);
			continue;
		}
		Display::parsePacket(buff);
		IPH* ip = (IPH*)buff;
		if(ip->protocol == IPPROTO_ICMP){
				tracker->pong(buff);
		} else { // we trace TCP or UDP connections
			int addr = (ip->daddr!=PacketMuncher::localHost)?ip->daddr:ip->saddr;
			if( !map->isListed(addr) ){
				tracker->startTrace(addr);
			}
		}
		time(&ltime);
		if( !(ltime%60) ){ // save route every 60 seconds
			map->writeRoute("!conmap.cns");
		}
		delete(buff); // it was allocated by packet muncher :)
	}
}