#include <winsock2.h>
#include <stdio.h>
#include <iostream.h>
#include "PacketMuncher.h"
#include "packets.h"
#include "conmap.h"
#include "Display.h"


char * Display::flagNames[] = {"FIN","SYN","RST","PUSH","ACK","URG"};

char * Display::tcpFlags(char flags){
static char sflags[30];
	sflags[0] = 0;					// initialize a string
	for(int i=0; i< 6; i++){		// for each flag
		if( flags&(1<<i) ){			// mask a flag
			if(sflags[0]){			// if string is not empty,
				strcat(sflags,"|");	// put a separator
			}
			strcat(sflags,flagNames[i]);
		}
	}
	return sflags;
}


void Display::fillName(unsigned long ipaddr,char * addr,char * name){
	HOSTENT * src = gethostbyaddr((char*)&ipaddr, 4, AF_INET);
	if(ipaddr == PacketMuncher::localHost){
		strcpy(addr, src->h_name);
		strcpy(name,"");
	} else {
 		strncpy(addr,inet_ntoa(*(in_addr *)&ipaddr),32);
		name[0]=0;
		if(src){
			sprintf(name, " (%s)", src->h_name );
		}
	}
}

void Display::printData( char * data, int size){
	char buff[10];
	sprintf(buff,"%05d ",size);
	cout << buff;
	for(int i = 0; i < 73 && i < size; i++){
		char c = data[i];
		if ( c < 127 && c >= ' '){
			cout << c;
		} else {
			cout << '.';
		}
	}
	cout << endl << endl;
}



void Display::parsePacket(char *packet){
char sa[32], da[32], sn[128], dn[128];
	IPH* ip = (IPH*)packet;
	unsigned short iphlen = (ip->verlen&0xF)<<2;
	char * transport = packet + iphlen; // + ipHeaderLengthField*4
	ICMPH* icmp = (ICMPH*) transport;
	TCPH* tcp = (TCPH*) transport;
	UDPH* udp = (UDPH*) transport;
	unsigned short tcphlen = (tcp->DataOffset&0xF)<<2;
	fillName(ip->daddr,da,dn);
	fillName(ip->saddr,sa,sn);
	if(ip->protocol == IPPROTO_UDP || ip->protocol == IPPROTO_TCP){ // tcp & udp have same port number offsets
			sprintf(sa+strlen(sa),":%d",ntohs(tcp->sport) );
			sprintf(da+strlen(da),":%d",ntohs(tcp->dport) );
	}
	cout <<sa<<sn<<" -> "<<da<<dn<<endl<<"size "<<ntohs(ip->totlen)<<" ttl "<< (int)ip->ttl << endl;
	switch(ip->protocol){
		case IPPROTO_TCP:
			cout << "TCP win " << ntohs(tcp->Windows) << " flags " << tcpFlags(tcp->Flags) << endl;
			printData( transport+tcphlen,ntohs(ip->totlen) - iphlen - tcphlen);
			break;
		case IPPROTO_ICMP:
			if( icmp->type == 8 || icmp->type ==0 ){
				cout << "ICMP PING sequence " << ntohs(icmp->sequence) << endl << endl;
			} else if(icmp->type == 11 && icmp->code == 0){
				IPH * encIP = (IPH*)(transport+8); // icmp has 4byte header + 4 reserved bytes
				ICMPH * encIcmp = (ICMPH*) (transport+28); // skip icmp+tcp to new icmp
				cout << "ICMP UNREACHABLE " << (int) icmp->code << " dest " << inet_ntoa(*(in_addr*)&encIP->daddr)
					<< " id " << ntohs(encIcmp->id) << " seq " << ntohs(encIcmp->sequence) << endl << endl;
			} else {
				cout << "ICMP type " << (int)icmp->type << " code "<< (int)icmp->code << endl << endl;
			}
			break;
		case IPPROTO_UDP:
			if(ntohs(udp->srcPort)==53 || ntohs(udp->destPort)==53){
				cout << "UDP (DNS)" << endl;
			} else {
				cout << "UDP" << endl;
			}
			printData( transport+8,ntohs(ip->totlen) - iphlen - 8); // udp header length is always 8 bytes
			break;
	}
}
