#ifndef PACKETS_H
#define PACKETS_H


// TCP flags
#define  TH_FIN   0x01
#define  TH_SYN   0x02
#define  TH_RST   0x04
#define  TH_PUSH  0x08
#define  TH_ACK   0x10
#define  TH_URG   0x20

typedef struct __tcp_hdr{
	unsigned short	sport;
	unsigned short	dport;
	unsigned int	seqnum;
	unsigned int	acknum;
	unsigned char	DataOffset;
	unsigned char	Flags;
	unsigned short	Windows;
	unsigned short	Checksum;
	unsigned short	UrgPointer;
} TCPH;


typedef struct __ip_hdr{
    unsigned char  verlen;  
    unsigned char  tos;
    unsigned short totlen;       
    unsigned short id;            
    unsigned short offset;        
    unsigned char  ttl;           
    unsigned char  protocol;      
    unsigned short checksum;      
    unsigned int   saddr;         
    unsigned int   daddr;         
} IPH;


typedef struct  __udp_hdr{
	unsigned short srcPort;
	unsigned short destPort;
	unsigned short length;
	unsigned short checksum;
} UDPH;


typedef struct __icmp_hdr{
 unsigned char  type;
 unsigned char  code;
 unsigned short checksum; 
 unsigned short id;
 unsigned short sequence;
 unsigned long  timestamp;
} ICMPH; 

#define ICMP_ECHOREP 0	// icmp types
#define ICMP_UNREACH 3
#define ICMP_ECHOREQ 8
#define ICMP_TIMEEX 11

#endif // PACKETS_H