#ifndef TRACERT_H
#define TRACERT_H

#include <winsock2.h>
#include "packets.h"

#define IP_TTL 4 // level=IPPROTO_IP option, Time To Live
#define MAX_HOPS 32

class TraceRoute{
	int scanCount;
	unsigned short traceID;
	unsigned int lastTTL;
	unsigned short routeLength;
	unsigned int route[MAX_HOPS+1]; // this table will store ips of every node on the route
	int sock;		// socket for sending icmp packet
	sockaddr_in to;	// address where the packet will be sent to
	ICMPH packet;	// PING packet that we are sending

	unsigned short cksum (unsigned short *buff, int size);
	int setTtl (int timeToLive);
	int end(); // this will end the ping
	int ping(int ttl);
public:
	unsigned int getTraceAddress(){ return route[0]; }
	TraceRoute();
	virtual ~TraceRoute();
// it is a responsibility of the instanciating program to call ping() at regular intervals of 500ms or so
	unsigned int * ping(); 
	int pong(char * packet); // every time an ICMP packet is captured of type 8,11 or 3 pass it here
	int initTrace(unsigned int addr, unsigned short id);
	void printRoute();
};

#endif